rn GENERAL INFORMATION (1)
ex Because of memory limitations not all routines listed in this documentation are available in each version of kawk. Routines carrying the note "NOT IN ALL VERSIONS" require a "MEDIUM MEMORY" compile for 8086 processors. Programs so compiled are slower than small memory models and EXTREMELY difficult to debug. Routines that are eliminated to save memory can be duplicated using other functions.

rn GENERAL INFORMATION (2)
ex The notation _?? as in _is or _nc in the text simply means the variable is or the variable nc. The underscore is used to make the variable name stand out from the surrounding text. It is NOT part of the actual variable name.

rn GENERAL INFORMATION (3)
ex Depending on the program and version, control characters may appear as either ^X or @X.

rn cdcond()
ex strip extra blanks (leading, trailing, and intervening) in the current card.
gr cards

rn cdsize()
ex return the total size of the current card in characters? .
gr cards

rn cdtox(is,ns)
ex converts a card read with rdcard() into string (one long line) format. _is is the receiving character array. _ns is the size of this array.
gr CARDS

rn setcheck(num)
ex turns off checking for unknown keys when num = 0 and turns on checking when num = 1. Turning off error checking allows reading and writing a file with a subset of all keys in that file.
no This option is also available in ked.
gr cards

rn xtocd(is)
ex converts a block for text read with xrdcd() into rdcard() format. with this conversion, individual fields may be addressed with $\&key variables.
gr CARDS

rn change(os,ns,is,ts,rs,gl)
ex changes one or more occurrences of the target string _ts to the replacement string _rs as specified by the number _gl. The routine returns the number of replacements actually made.
no This routine is functionally equivalent to the "s/pattern/replacement/" command in ed, sed or ex. Escapes (\) can be a problem with this routine. See the discussion of formats and escapes and the example program.
xf change.kwk
gr changes

rn dater(os,ns,is)
ex converts dates of the form year:month:day to the form day month year. 1941:12:7 becomes 7 December 1941.
no this routine modifies the input string "is". If you will be using it later in your program, give dater() a copy of "is".
gr changes

rn litrep(os,ns,is,ts,rs,nr)
ex replace the first nr cases of ts in is with rs placing the modified output in os. This is a faster version of the change function without provision for regular expression "wild cards." The pattern and replacement are taken absolutely literally.
gr changes

rn undater(os,us,is)
ex reverses the operation of dater(). Dates of the form day month year become year:month:day. For example, 7 December 1941 becomes 1941:12:7.
no Dates of the form produced by undater() will NOT sort properly beyond the year level. undater() modifies the input string "is". If you will be using it later in your program, give undater() a copy.
gr changes

rn xtoy(os,c1,c2)
ex change all cases of character c1 to character c2.
no c1 and c2 are single characters, not strings.
gr changes

rn chrcnt(is,cx)
ex return the number of cx characters in string is.
gr characters

rn cindex(is,cc)
ex returns the position of the single character cc in the string is. If cc is not found, -1 is returned.
no NOT IN ALL VERSIONS.
gr characters

rn crindex(is,cc)
ex returns the position of the last occurrence of cc in the string is. If cc is not found, -1 is returned.
no NOT IN ALL VERSIONS.
gr characters

rn isalnum(c1)
ex return true if the single character c1 is upper or lower case or a digit.
gr characters

rn isalpha(is,c1)
ex return true if the single character c1 is alphabetic (upper or lower case).
gr characters

rn isdigit(c1)
ex return true if the single character c1 is a digit.
gr characters

rn islower(c1)
ex return true if the single character c1 is lower case.
gr characters

rn isprint(c1)
ex returns true if the single character c1 is a printable character.
gr characters

rn ispunct(c1)
ex returns true if the single character c1 is punctuation.
no See UNIX or XENIX documentation for the precise definition of "punctuation."
gr characters

rn isspace(c1)
ex returns true if the single character c1 is a space (including tabs, line feeds and carriage returns.
gr characters

rn isupper(c1)
ex returns true if the single character c1 is upper case.
gr characters

rn strtime(os,nc,is)
ex returns the current time in string _os of size _nc according to the format given by string _is.
no To see the availalable formats use "%?" for string _is.
gr DATE

rn abort() || abort("message")
ex causes an IOT trap without or with a message. the resulting core image can be examined with adb.
gr diagnostic

rn exit() || exit(num)
ex exit with status zero or status given by num. in interactive mode, causes a SIGINT/FUBAR condition to halt execution.
gr diagnostic

rn funxesc(os) || funxesc(os,fp)
ex the one parameter case writes to the current output file. the two parameter cae writes to a file pointer obtained from a previous call to fopen(). the string os is written so that control characters appear as @X, @Z, etc. characters with the high-order byte on appear as \128, \129, etc.
no this routine is useful for listing files that have embedded control characters. it is also useful for checking on escape expansion in calls to routines such as setrex().
gr diagnostic

rn prtsym()
ex will dump the internal symbol table to the stdout.
no NOT IN ALL VERSIONS.
gr diagnostic

rn access(name,[0|1|2|3|4])
ex returns zero if the the specified file mode (taken from UNIX access) is available for the named file.
gr files

rn count()
ex returns the input record count.
gr files

rn fclose(file)
ex close a file opened with fopen(). "file" is the file pointer returned by fopen().
gr files

rn fflush() || fflush(file)
ex forces a flush of stdout (the zero parameter case) or of the file specified by the single parameter.
xref fopen, fclose.
gr files

rn fgetlerr()
ex returns 1 if the last call to fgetls() or fgetlf() was an error due to a long line. zero (0) is returned if there was no error.
no fgetls() and fgetlf() return end-of-file (NULL) for both a true end-of-file and for errors. calling fgetlerr allows distinguishing between the two cases.
gr files

rn fgets(os,ns,file)
ex reads from a file pointer returned by fopen and places the result in the buffer os. This routine may be used in lieu of kuso to allow processing of another file.
no unlike its UNIX namesake, this routine strips terminating linefeeds. it also joins lines ending in a backslash.
xf fgets.kwk
xref fgetlerr, fopen, fclose, fgetlf, fgetls
gr files

rn filemod(is)
ex return a pointer to a string giving the last modification time of the specified file.
gr files

rn filenum()
ex returns the current input file number.
no This follows C conventions; if you have three input files, this function will return 0, 1, 2 as kawk cycles through the files.
gr files

rn filesize(is)
ex returns the size in blocks (512 characters) of the file named by string is.
no A negative value is returned for errors.
gr files

rn fopen(sa,mo)
ex open the file named in sa with the mode given in mo.
no Mode is a string ("r", "w", or "a"), NOT a character constant.
gr files

rn fseek(fp,ad,po)
ex position the file pointer _fp to the address _ad relative to the beginning of the file (_po = 0), the current position (_po = 1) or the end of the file (_po = 2). _fp is a file pointer returned by the fopen() function. if _fp = 0, the fseek() acts on the current (default) input file; if _fp = 1, fseek() acts on the current (default) output file.
no because kawk currently lacks long integer variables, _ad must be declared to be a double. it is converted internally to a long for the call to the system function fseek().
xref fopen(), fclose(), rewind()
gr files

rn infile() || infile(num)
ex with no parameter, return the current file name when using rdcard or rdline. With one parameter return the num-th name in the input file list.
no The no parameter case may return garbage before a call to rdcard or rdline has been issued.
gr files

rn link(name_one,name_two)
ex makes a link to name_one. This link has name_two.
gr files

rn mktemp(is) || maketemp(is)
ex makes a unique file name from the string is which must have six upper cases Xs as the last characters in it.
gr files

rn rewind() || rewind(fp)
ex with no parameters rewinds the whole file list given on the command line to kawk. With one parameter (a file pointer returned by fopen), rewinds the specified file.
no rewind is especially useful in programs to generate form letters and mailing lists.
xref fopen, fclose, fgets, readcard
gr files

rn setfile(is) OR setofn(is)
ex set the list of files to be read by kawk when the rdcard and rdline functions are called. This routine overrides any list of input files specified on the command line or by the 'r' option in interactive mode.
no Either name may be used for this routine.
gr files

rn setifn(is) || setifn()
ex set the input file list to the contents of string is. this function uses the same mechanism as the 'r' command in interactive mode. wild cards and shell variables are expanded. if no list is given, the last input file list is rewound.
no setifn() overrides file names given on the command line or through the interactive "r" option. when using the interactive mode of kawk and setifn() to read an intermediate scratch file, it is necessary to use the "r" command to reset the input file list after each test run.
xref rewind()
gr files

rn setofn(), setofn(file_name), setofn(file_name,mode)
ex In the first form, the output is set to stdout. In the second form, the output file is opened for writing. In the third form, an output mode is supplied. This should be "a" that opens file_name to append. setofn can be used in combination with setfile to produce intermediate files that are processed by kawk or by other programs.
no mode is a character string, not a single character constant.
gr files

rn unlink(is)
ex remove the named file (equivalent to the shell rm command).
gr files

rn crchash(is,mv)
ex returns an integer hash value for string _is. _mv is the value used in the modulo calculation. it should be a prime number such as 251 or 4091.
gr HASHING

rn crcsum(is)
ex computes a check sum for the string is. this checksum is returned as a double value.
gr HASHING

rn iskey(is)
ex true if the string is is a proper key.
gr keys

rn keycat("key",is) || keycat("key",is,ss)
ex adds is to the key field by "key" separating the two by the string ss if specified.
no key must be quoted with this routine: "aut" and not $aut.
xf keycat.kwk
gr keys

rn keycnt()
ex return the number of non NULL fields in the current card.
gr keys

rn keytac("key",is) || keytac("key",is,ss)
ex same as keycat except is placed at the head of the string.
gr keys

rn keyzap("key")
ex sets the specified key to NULL.
no The key must be specified as a string, not as a $key variable.
gr keys

rn nextkey(nc)
ex allows a sequential loop through each valid data field on a card. nextkey(0) resets the loop. nextkey(1) returns the first valid key with data or NULL if there are no more keys with data. nextkey(2) returns the number of the last valid key. nextkey(3) returns the shorter key for the last valid key. nextkey(4) returns the longer key for the last valid key. nextkey(5) returns the explanatory field from the keys file for the last valid key.
xf nextkey.kwk
gr keys

rn kuso(is)
ex opens and reads the files given in the string is. Output from these files is merged with that from kawk. Because the files are written directly to the output, no processing of them can be done within kawk.
no NOT IN ALL VERSIONS
xf kuso.kwk
gr kuso

rn kusopipe(is)
ex reads from a pipe created according to the command in string is. The output from this command is merged with the output from kawk.
no NOT IN ALL VERSIONS
gr kuso

rn pclose()
ex closes a pipe opened with a call to pipe("command") and resets the output file to stdout.
no NOT IN ALL VERSIONS.
gr kuso

rn pipe(is)
ex pipes the output from kawk through the command specified by the string is. If is has been set equal to "nroff -ms", kawk output will be passed to nroff. This command should be used before any code in kawk that generates output.
no NOT IN ALL VERSIONS
gr kuso

rn source(is)
ex merges the output from the file specified by is with that from kawk.
no NOT IN ALL VERSIONS
gr kuso

rn andlist(os,ns,is)
ex produces a copy of the string is in os in which items of the form "one; two; three; four" have been converted to "one, two, three, and four." Spurious blanks are removed.
no This routine is primarily for use with reverse. os and is may be identical if (a) os in not a key and (b) is large enough to hold the original string plus ", and ."
gr logical

rn orlist(str1,str2,strN)
ex returns the first non NULL string in the list.
gr logical

rn rand()
ex returns a pseudo random number each time the function is called.
gr MISC

rn atof(is)
ex converts a string into a double precision floating point number.
gr numerical

rn atoi(is)
ex converts a string into an integer.
gr numerical

rn maximum(num1,num2,numN)
ex return the largest number.
no use with integer variables only.
gr numerical

rn minimum(num1,num2,num3)
ex return the smallest number.
no use with integer variables only.
gr numerical

rn cmdnum(flag,default_1,default_2)
ex returns values associated with -xNN patterns on the command line. For example, cmdnum('X',69,96) with -X13 on the command line will return 13. If there is no -XNN, 69 is returned. If -X (with no following number) appears, 96 is returned.
xref cmdstr
gr options

rn cmdstr(flag,default)
ex returns string arguments from the command line. For example, if kawk is called with '-H this is the header', cmdstr('H',NULL) will return the string "this is the header". 'default' may be used to supply a default string. For example, cmdstr('H',"nuts") will return the string "nuts" if no '-H string' pattern appears on the command line.
xref cmdnum
gr options

rn setked(num)
ex sets the keyio buffer to num. This is equivalent to $buffer=num in the.keys.
gr options

rn setwork(num)
ex sets the size of the work area used by the printf command. Without specification this work area defaults to BUFSIZ.
gr options

rn getrex(os,is)
ex reports true if the pattern in string is is found in string os. All regular expression items such as '*' and '[a-z] ' are usable in is.
no The kawk string processor expands certain escape (\) sequences and turns items such as ^A and ^Z into control characters. An extra escape may be necessary to force certain characters to be taken literally.
gr patterns

rn haspat(ss,ts)
ex if the pattern given by string ts occurs in string ss, haspat returns a pointer to the beginning of ts in ss, otherwise NULL. the search for ts uses strkmp; case is ignored and only alphanumeric items are considered.
gr patterns

rn setrex(is)
ex compiles the string is into the form use by the pattern matching routine. The string is may contain all the usual wild cards of ex and vi patterns.
no Be wary of extra expansions of patterns with backslash and caret characters in them.
xref userex
gr patterns

rn strloc(is,ts)
ex returns a pointer to the first instances of target string ts in input string is. Target string ts is taken literally. No wild cards are significant.
no This is the most efficient kawk pattern finding routine. Use it when elaborate matching is not needed.
gr patterns

rn userex(is)
ex returns true if string is matches a previously compiled (setrex) expression.
no This combination is used to improve efficiency when kawk is used as a simple pattern matching program.
xf userex.kwk
xref setrex
gr patterns

rn clcard()
ex clears all data fields of the internal card buffer to NULL.
no this routine is called automatically by rdcard() but may be necessary when building cards without use of rdcard().
gr read

rn drawline(num,is)
ex write num cases of is.
no NOT IN ALL VERSIONS
gr read

rn fgetlf(os,ns,fp)
ex reads lines of up to ns characters into the character array os. backslash-line feed combinations are translated to a single blank. fp is obtained from fopen.
no to preserve backslash-line feed combinations, use fgetls.
xref fgetlerr, fopen, fclose, fgetlf, fgetls
gr read

rn fgetls(os,ns,fp)
ex reads lines of up to ns characters into the character array os. fp is obtained from fopen.
no fgetls does NOT join lines ending in a backslash.
xref fgetlerr, fopen, fclose, fgetlf, fgetls
gr read

rn getc(fp)
ex returns a single character from the stream indicated by fp (obtained from a call to fopen).
xref fopen, fclose, ungetc
gr read

rn getchar()
ex returns a single character from the standard input.
gr read

rn rdcard() || rdcard(fp)
ex with no parameters rdcard() assumes the files named on the command line or set by the setinf() command. with one parameter rdcard() reads from a file pointer (int) returned by a previous call to fopen(). individual fields of a card read by rdcard() are addressed by the form $key.
xref wrcard, fopen, xrdcd
gr read

rn rdline(os,ns) || rdline(os,ns,fp)
ex the two parameter form uses the file list given on the command line or set by setinf(). the three parameter form reads from the file pointer _fp provided by a previous call to fopen(). _os is a string array of size _ns.
no rdline() calls fgetlf() and will join lines ending in a backslash. to avoid this uses fgetls().
gr read

rn ungetc(cx,fp)
ex returns the single character cx to the stream fp (obtained from a call to fopen). a subsequent call to getc will return cx. cx need not have been obtained by a previous call to getc.
xref fopen, fclose, getc
gr read

rn xrdcd(os,ns) || xrdcd(os,ns,fp)
ex read a card as one long line. This routine may be used when you are interested in cards as units but are not concerned with individual fields. the two parameter version uses the command line file list or that provided by setifn(). the three parameter version uses a file pointer from a previous call to fopen().
no $key operators cannot address fields when this routine is used. Cards read with this routine may be written with those functions used to address ordinary strings.
gr read

rn xwrcd(os)
ex writes a card that has been read with the xrdcard command (as one long string). Individual keys cannot be addressed when cards are processed as long strings.
gr read

rn capital(is)
ex capitalizes the first letter of each word in string is.
no The routine is dumb. It will miss words that begin with punctuation.
gr strings

rn index(is,cc)
ex returns a pointer to the first instance of cc (a character constant) in string is.
gr strings

rn isnull(is)
ex returns true (non zero) if the string is is NOT NULL.
no NULL means either zero length or nonexistent in this case.
gr strings

rn numhow()
ex returns the number of distinct strings catalogued by numstr.
xref numstr, strnum, strhow
gr strings

rn numstr() || numstr(is)
ex associates a unique number (0 through n) with each DIFFERENT string is. Repeated calls with the same input string return the same number. numstr() clears the list maintained by numstr. This function may be used as a substitute for the associative arrays of awk.
xf grades.kwk
xref numhow, strhow, strnum
gr strings

rn reverse(os,ns,is)
ex produces a reversed order version of the names in string is. Names are presumed to be in the format "last_name, first_name; last_name, first_name; etc." The routine is moderately intelligent. It works properly with most multipart names, jr., sr., etc. Spurious blanks are removed by this routine.
no For really nasty cases it may be necessary to use pattern replacement to get a proper reversal. Or, you may simply give the name in two different forms in your bibliography. The arrays os and is may be the same unless they are keys ($abc variables).
xref andlist
gr strings

rn rindex(is,cc)
ex returns a pointer to the last instance of cc (a character constant) in string is.
gr strings

rn sprintf()
ex replaced by sformat.
gr strings

rn strcat(os,is)
ex appends string is to os which must be a null terminated string or the routine will bomb.
gr strings

rn strcmp(os,is) || stricmp(os,is)
ex returns the lexical difference between os and is. If os and is are exactly the same, strcmp returns zero. The comparison is character by character. stricmp() ignores case.
gr strings

rn strcnd(is)
ex strips leading and trailing blanks from the string is.
gr strings

rn strcnt(is,cx)
ex return the number of cx characters in string is.
no strcnt() and chrcnt() are identical.
gr strings

rn strcpy(os,is)
ex copy is to os.
no strcpy and strncpy do NOT check that os is large enough to receive is.
gr strings

rn strfold(is,fw)
ex folds the string is on the last blank (space or tab) before fw, an integer. strfold is invoked by the %S format option of printf and sformat.
gr strings

rn strhow()
ex returns the number of distinct strings catalogued by numstr.
no strhow() and numhow() are identical.
xref numhow, strnum, numstr
gr STRINGS

rn strkmp(os,is)
ex compare strings os and is ignoring blanks and punctuation. A zero return indicates equality.
gr strings

rn strlen(is)
ex returns the length (number of characters) in string is.
gr strings

rn strlwr(is)
ex converts all characters in string _is to lower case.
gr strings

rn strncat(os,is,nc)
ex append the first nc characters of is to os.
no See the caveats for strcat and strcpy.
gr strings

rn strncmp(os,is,nc) || strnicmp(os,is,nc)
ex compare the first nc characters of os and is in the manner of strcmp. strnicmp() ignores case.
gr strings

rn strncpy(os,is,nc)
ex copy nc characters from is into os. If is is longer than nc characters, os will NOT have a NULL at the end. To put one there use "os[nc] = NULL; "
gr strings

rn strnkmp(os,is,nc)
ex compare the first nc characters of os and is ignoring blanks and punctuation.
gr strings

rn strnrev(is,nc)
ex reverses the first nc characters of is.
gr strings

rn strnum(nn)
ex returns the string associated with nn, a number previously returned by numstr.
xref numstr
gr strings

rn strrev(is)
ex reverses the character order of is.
gr strings

rn strsave(is)
ex saves a string in a block of core allocated for this purpose. This block may be deallocated with strfree(). When used with an array of integer/pointers, the result is similar to having a dynamic, multi-dimensional array.
gr strings

rn toalnum(is)
ex strips all non-alphanumeric characters from is AND removes all cases of repeated blanks. The resulting string is intended for "dictionary" comparisons.
no This routine is unsophisticated. It will botch complex nroff/troff constructions involving accent marks. For these cases you need to use an appropriate script with change().
gr strings

rn words(is)
ex returns a count of the words in string is.
no NOT IN ALL VERSIONS.
gr strings

rn dgetsub(os,ns,is,c1,c2)
ex extracts the n1 through n2 subfields marked by a dollar sign followed by one alphanumeric character as in $1, $b, etc. Such forms appear in MARC (Library of Congress) records as returned by MLEVYL. c1 and c2 are character constants. To pull the $b field in a record use dgetsub(os,ns,is,'b','b'). To pull the $2 through the $4 fields, use dgetsub(os,ns,is,'2','4').
no Subfields need not be in ascending order to be pulled. If none of the requested fields are found, os will contain a single NULL.
gr subfields

rn getqs(xp,nxp,is)
ex splits the string is into a series of substrings in array xp of size nxp. This routine splits on blanks, double quotes, or single quotes. Within a double quoted string, single quotes have no special meaning. Within a single quoted string, double quotes have no special meaning. Usage is similar to splitc.
gr subfields

rn kgetsub(os,ns,is,ks)
ex extracts subfields of the form key=string. Given a line of "aut=Kinmonth, Earl H. vt=Self-Made Man", a call of kgetsub with ks set to "vt" will return "Self-Made Man". If the requested field does not exist in the line, os is set to a null string.
gr subfields

rn sgetsub(os,ns,is,cx,f1,f2)
ex returns in os the n1 through n2 subfields delineated by the single character (not a string) cx. If the specified subfields are not found, the string os is zero length, containing only a single NULL character. This may be used to terminate a loop as in the example below. The returned string may have leading blanks. Use strcnd to remove these.
no Following C conventions, the first field is numbered zero.
xf getsub.kwk
gr subfields

rn splitc(xp,nxp,is,cc)
ex splits the input string is at cc (a character constant) producing a pointer to each split field in the array xp of size nxp.
xf splitc.kwk
gr subfields

rn transpose(os,is,num)
ex transposes the n1-th case of the is delineated fields to the head of the string.
no is is a string although it may be only one character long. The same function is available in edcd. NOT IN ALL VERSIONS.
gr subfields

rn xgnc(os,nos,is,cc)
ex copies string is up to the first occurrence of cc placing the result in os. It returns a pointer to the first character after cc, which is eliminated from the output string.
xf xgnc.kwk
gr subfields

rn chdir(is)
ex changes the working directory to that specified by the string is.
gr system

rn compile(is)
ex compiles and executes the kawk programme named by the string _is (variable or constant). the new programme replaces the current one, inheriting only its list of input files (if any).
gr system

rn expander(os,ns)
ex expands file names containing shell variables. the string os contains the name(s) to be expanded. its size ns must be large enough to hold the expanded list.
no under UNIX strings resulting from calls to other programs are also expanded.
gr system

rn getenv(is)
ex returns a pointer to the shell environment variable called for by string is. getenv("HOME") will return the user's home directory.
gr system

rn getwd()
ex returns the current working directory. This is what the pwd shell command returns.
gr system

rn sleep(nc)
ex causes execution to pause for nc seconds. Resumption of execution is automatic.
no NOT AVAILABLE IN MSDOS VERSION.
gr system

rn system() || system(sa) || system(sa,sb) || system(sa,sb,sc)
ex executes shell commands. In the zero parameter case, a shell is forked. In the one parameter case, the command sa is executed. In executing commands, system looks for three special symbols. An exclamation point (!) is replaced by any previous command. A percent sign is replaced by the current list of input files (or by sb if given). A sharp (pound) (#) sign is replaced by the current format file (or by sc if given).
no system automatically flushes the stdout or output to a pipe. If you have used fopen to write to a file and then wish to use a script called by system on this file, you should first close the file, or at least flush it. Otherwise the file may be missing some portion of the last BUFSIZ characters when the script called by system starts acting on the file.
gr system

rn kwt(is) || kwt()
ex writes is to the terminal or "? " with a beep if is is not given. This routine opens the terminal file directly if necessary.
no NOT IN ALL VERSIONS.
gr terminal

rn query()
ex displays the message "<more?> on the user's terminal and waits for a response. a space or carriage return causes query to return, allowing execution to continue. this is the same routine used throughout Bibliofile for pausing the terminal output.
gr terminal

rn rdterm(os,ns)
ex reads up to ns characters or one line into os from the terminal. This routine will open the terminal file directly if necessary.
no NOT IN ALL VERSIONS
gr terminal

rn slowit(num)
no replaced by query()
xref query()
gr terminal

rn fprintf(file,format,var1,var2,varN)
ex writes a formatted version of each of the variables to the stream pointed to by file (returned from an fopen).
xref printf, fopen, fclose.
gr write

rn fputs(os) || fputs(os,fp)
ex writes the string _os to the standard output stream of kawk. if the optional parameter _fp (obtained from a call to fopen()) is given, output is directed to a specific file. fputs() does NOT fold and does NOT append a line feed.
xref puts(), putsf(), printf()
gr write

rn printf(format,var1,var2,varN)
ex writes a formatted version of each of the variables on the standard output stream. All standard C/awk format conventions are available plus the extensions listed in the table below.
no Unless setwork(size) is used, printf uses a BUFSIZ buffer that is flushed after each call.
gr write

rn print(format,var_1,var_2,var_N)
ex produces a formatted version of the specified variables on the standard error stream.
no Do not confuse this routine with printf, puts, etc., all of which write to the stdout or pipe. This routine is primarily for writing diagnostic messages to the terminal.
gr write

rn putchar(cx)
ex writes the single character cx to the standard output.
gr write

rn putsf(os) || putsf(os,fp) || putsf(os,fp,fw)
ex writes the string _os to the standard output stream of kawk folding on the first blank after the fold point (setfold), appending a line feed. The optional parameter _fp (obtained from a call to fopen()) directs output to a specific file. The optional parameter _fw sets the fold width (for this line only) to the specified value.
xref puts(), fputs(), printf()
gr write

rn puts(os) || puts(os,fp)
ex writes the string os to the standard output stream. If the optional parameter _fp (obtained from a call to fopen()) is given, output is directed to a specific file.
xref putsf(), fputs(), printf()
gr write

rn setfold(num)
ex sets the folding point for writes using printf and wrcard. The fold point is originally set at 56.
gr write

rn sformat(os,ns,format,var1,var2,varN)
ex places a formatted version of each of the variables in os using the format specified by is. This routine is useful when a string must be built in parts and then modified before writing.
no Note that the kawk sformat requires a size specification for os. This is designed to catch overflow.
gr write

rn wrcard() || wrcard(fp)
ex writes a card previously read by rdcard() to either the default output (no parameter case) or to the file pointed to by _fp (derived from a previous call to fopen()). if the output file appears to be a terminal, long lines are folded.
gr write

rn wrcard(is)
ex write a card to the stdout folding if this is a terminal.
gr write

rn writecard(file) || writecard(file,style)
ex write in card format to file, a pointer returned by fopen. style is a single character constant from the set 'f' = folding, 'w' = wide (usual), or 'l' = list (shows control characters and line boundaries).
xref readcard, rdcard
gr write

