/*COMLIB*/
#define		DEBUG
#undef		DEBUG
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#define		HINTLIST		"hintlist.hyo"
/**/
/*EXTERN*/
extern char *findfile();
extern  KENV    kenv;
/**/
void
khint(os,is)	    /* for backward compatability */
char    *os;
char    *is;
{
	fnhint(os,is,ZERO);
	return;
}
void
fnhint(os,is,ty)	/* read hint from a file */
char    *os;	    /* file name */
char    *is;	    /* context (not implemented) */
int    ty;	      /* type (not implemented) */
{
	auto    char    ws[FNMSIZ];
	auto	int		found;
	auto	char	*pubkin;
/*
**      this routine does double duty to list key files; in this case
**      the raw file name is used as passed by khint.
*/
	if(access(os,04) == 0)  {
		rdhint(os,is,ty);
		return;
		}
/*
**		otherwise consult to hintlist.hyo file
*/
	pubkin = kgetenv("PUBKIN");
/**/
	if(isnull(pubkin))	{
		errmsg("<environment variable PUBKIN undefined>\n");
		return;
		}
/**/
	strcpy(ws,pubkin);
	strcat(ws,"/MAN");
	if(kchdir(ws))	return;
/**/
	hintlist(os);
	return;
}
hintlist(os)
char	*os;	/* what we want */
{
	auto	FILE	*fp;
	auto	char	ls[FNMSIZ];
	auto	int		found = 0;
	auto	char	*eop;
/**/
	fp = tefopen(HINTLIST,"r");
	while(fgetls(ls,ls+FNMSIZ-1,fp))	{
		if(ls[0] == '#')		continue;
		if(stricmp(ls,os) == 0)	{
			found = 1;
			break;
			}
		}
	fp = xfclose(fp);
	if(!found)	{
		errmsg("<not in the hint data base> '%s'\n",os);
		return;
		}
/**/
	eop = ls + strlen(ls);
	strcpy(eop,".ref");
#ifdef	DEBUG
	fprintf(stderr,"ls(%s,%d)\n",ls,access(ls,04));
	query(stderr);
#endif	/*DEBUG*/
	if(access(ls,04) == 0)	{
		rdhint(ls,NULL,0);
		}
	else	{
		*eop = NULL;
#ifdef	DEBUG
	fprintf(stderr,"ls(%s)\n",ls);
	query(stderr);
#endif	/*DEBUG*/
		xuhint(ls,NULL,0);
		}
		return;
/**/
}
xuhint(os,is,ty)
char	*os;
char	*is;
int		ty;
{
	auto	char	ws[FNMSIZ];
	auto	int	rt;
	sprintf(ws,"%s -h",os);
#ifdef	DEBUG
	fprintf(stderr,"ws(%s)\n",ws);
	query(stderr);
#endif	/*DEBUG*/
	rt = system(ws);
	if(rt)	{
		perror(ws);
		}
	return(rt);
}
static  FILE    *hfp = NULL;
static  char    *hbs = NULL;
void
rdhint(os,is,ty)
char    *os;
char    *is;
NOSIGN	ty;
{
	auto    char    hbuf[FNMSIZ];
/**/
	hfp = xfclose(hfp);
/**/
	hfp = efopen(os,"r");
/**/
	hbs = hbuf;
/**/
	prhint( (char **) NULL, 9999, is, ty);
/**/
	hfp = xfclose(hfp);
/**/
	hfp = NULL;
	hbs = NULL;
/**/
	return;
}
prhint(hx,nl,tx,ty)
char    **hx;	   /* hint text vector */
int	nl;		/* items in _hx */
char    *tx;	    /* text item */
NOSIGN	ty;		/* function request */
{
	auto    char    *is;	/* string to print */
	auto    char    lo = YES;   /* loop switch */
	auto    FILE    *fp = stdout;
	auto    int     leisur = kenv.leisur;
	auto    int     screen = kenv.screen;
	auto    int     linesw = ZERO;
	auto    int     qu = NO;
/**/
	if(ty & DA)     fp = stderr;
/**/
	kenv.leisur = isatty(fileno(fp)) ? (DA | DB) : NO;
/**/
	kenv.screen = kenv.screen >= 1 ? kenv.screen : 22;
/**/
	scr_cl(fp);
/**/
	while(lo && --nl >= ZERO)       {
		qu = NO;
		if(hx)  is = *hx++;
		else
		if(!fgetls(hbs,hbs+FNMSIZ-1,hfp))       {
			lo = NO;
			continue;
			}
		else    is = hbs;
/**/
		if(*is == '=')  {
			linesw += prhash(is+1,fp);
			}
		else
		if(*is == '~' || linesw >= kenv.screen) {
			linesw = ZERO;
			if(query(fp) == 'q')    {
				lo = NO;
				qu = YES;
				continue;
				}
			scr_cl(fp);
			}
		else    {
			hafputs(is,fp);
			linesw += 1;
			}
		}
/**/
	if(!qu) query(fp);
/**/
	kenv.leisur = leisur;
	kenv.screen = screen;
/**/
	return(nl);
}
hascr_cl(fp)
FILE    *fp;
{
	if(!kenv.leisur)	return(ZERO);
	else		    return(scr_cl(fp));
}
haquery(fp)
FILE    *fp;
{
	if(!kenv.leisur)	return(ZERO);
	else		    return(query(fp));
}
prhash(os,fp)
char    *os;
FILE    *fp;
{
	auto	char	*hash = "==========";
	hafputs(hash,fp);
	if(!isnull(os)) {
			if(kenv.leisur) scr_so(fp);
			hafputs(os,fp);
			if(kenv.leisur) scr_se(fp);
			hafputs(hash,fp);
			return(3);
		}
	return(1);
}
hafputs(os,fp)
char    *os;
FILE    *fp;
{
	fputs(os,fp);
	if(kenv.dosdos) fputs("\r\n",fp);
	else	    	fputs("\n",fp);
	fflush(fp);
	return(ZERO);
}
#ifdef	TEST
KENV	kenv;
void
terror(ty)
{
	exit(ty);
}
main()
{
	auto	char	ls[BUFSIZ];
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])	{
		case	'q':	exit(0);break;
		case	'!':	system(ls+1);break;
		case	'#':	fnhint(ls+1,NULL,0);break;
		}
}
#endif
