/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	<time.h>
typedef	struct	tm	TM;
/*EXTERN*/
extern	long	time();
extern	TM		*localtime();
/*STATIC*/
static  char    *month[] = {
"January",
"February",
"March",
"April",
"May",
"June",
"July",
"August",
"September",
"October",
"November",
"December"
};
static  char    *weekday[] = {
"Sunday",
"Monday",
"Tuesday",
"Wednesday",
"Thursday",
"Friday",
"Saturday"
};
static	char	*hint[] = {
"%D    year day (number)",
"%H    hours (00)",
"%M    month (name)",
"%P    PM or AM",
"%R    raw (4 byte number)",
"%W    day (name)",
"%Y    year (0000)",
"%d    day of month (number)",
"%e    day of month (00)",
"%h    hours (0)",
"%l    month (abbreviated)",
"%m    minutes (00)",
"%n    month (number)",
"%p    pm or am",
"%s    seconds (00)",
"%w    day (abbreviated)",
"%y    year (00)",
NULL,
}	;
char	*
strtime(os,us,is,ti) 	/* formattable time function */
char	*os;			/* output string */
char	*us;			/* _os limit */
char	*is;			/* format */
long	ti;				/* time */
{
	auto	char	ws[FNMSIZ];
	auto    char    *osx = os;
	auto    char    *usx = us;
	auto    char    *isx = is;
	auto	long	barf;
	auto	TM		*tmx;
	auto	char	*tx;
/**/
	if(isnull(isx))	isx = "%y:%n:%d";
/**/
	if(ti)	barf = ti;
	else	{
		time(&barf);
		tmx = localtime(&barf);
		}
/**/
	for( ; osx < usx && *isx != ZERO; ++isx)	{
	if(*isx == '%') {
		switch(*++isx) {
			case	'?':
				{
				auto	char	**hx = hint;
				while(*hx)	puts(*hx++);
				return(NULL);
				}
			case	'R':
			case	'r':
				sprintf(tx = ws,"%ld",barf);
				break;
			case	'S':
			case 	's':	
				sprintf(tx = ws,"%02d",tmx->tm_sec);
				break;
			case	'm':
				sprintf(tx = ws,"%02d",tmx->tm_min);
				break;
			case 	'a':
			case 	'p':
				tx = tmx->tm_hour >= 12 ? "pm" : "am";
				break;
			case 	'A':
			case 	'P':
				tx = tmx->tm_hour >= 12 ? "PM" : "AM";
				break;
			case	'H':
			case	'h':
				sprintf(tx = ws,"%02d",tmx->tm_hour);
				break;
			case	'd':
				sprintf(tx = ws,"%d",tmx->tm_mday);
				break;
			case	'e':
				sprintf(tx = ws,"%02d",tmx->tm_mday);
				break;
			case 	'n':
				sprintf(tx = ws,"%02d",tmx->tm_mon+1);
				break;
			case	'l':
				sprintf(tx = ws,"%3.3s",month[tmx->tm_mon]);
				break;
			case	'L':
			case 	'M':
				tx = month[tmx->tm_mon];
				break;
			case	'y':
				sprintf(tx = ws,"%02d",tmx->tm_year);
				break;
			case 	'Y':
				sprintf(tx = ws,"19%02d",tmx->tm_year);
				break;
			case	'w':
				sprintf(tx = ws,"%3.3s",weekday[tmx->tm_wday]);
				break;
			case 	'W':
				tx = weekday[tmx->tm_wday];
				break;
			case 	'D':
				sprintf(tx = ws,"%03d",tmx->tm_yday+1);
				break;
			default:
				*osx++ = '%';
				*osx++ = *isx;
				continue;
			}
	osx = strkat(osx,usx,tx);
	}	/* end of if */
	else    {
		*osx++ = *isx;
		}
	}
	*osx = ZERO;
	return(os);
}
#ifdef  TEST
main()
{
	char    ls[BUFSIZ];
	char    bs[BUFSIZ];
	auto	long	ti;
	extern	long	atol();
	ti = 0L;
	strcpy(bs,"%Y %L %D");
	while(putchar('?'),fflush(stdout),gets(ls))
	switch(ls[0])   {
	case    'q':    exit(0);
	case    'h':    strtime(NULL);
					break;
	case	't':	ti = atol(ls+1);
					break;
	default:		strtime(bs,bs+BUFSIZ-1,ls,ti);
					puts(bs);
					break;
	}
}
#endif
