/*DOSLIB*/
#ifdef	__TURBOC__
/*DOSLIB*/
#include	<stdio.h>
#include	<fcntl.h>
#include	<time.h>
#include	<dos.h>
#include	<io.h>
#include	<sys/stat.h>
#define		U2D		1
#define		D2U		2
/*EXTERN*/
extern long ktimeutd(long);
extern long ktimedtu(long);
extern long ktimestd(long,int);
extern void terror(int);
extern long dtimestd(void);
extern long utimestd(void);
/**/
utime(is,mt)	/* TURBOC equivalent to **IX utime() */
char	*is;	/* file name */
long	mt[];	/* st_atime, st_mtime */
{
	auto	struct	ftime	dt;
	auto	struct	tm		*ut;
	auto	int		handle;
	auto	int		status;
/*
	provide a **IX style utime function for Turbo C
*/
#ifndef	TEST
	if(mt[0] != mt[1])	{
		fprintf(stderr,"utime <time error>\n");
		terror(69);
		}
#endif	/*TEST*/
	ut = localtime(&mt[0]);
	dt.ft_tsec = ut->tm_sec / 2;
	dt.ft_min = ut->tm_min;
	dt.ft_hour = ut->tm_hour;
	dt.ft_day = ut->tm_mday;
	dt.ft_month = ut->tm_mon + 1;
	dt.ft_year = ut->tm_year + 1900 - 1980;
	handle = open(is,O_RDONLY);
	if(handle < 0)	{
		return(-1);
		}
	status = setftime(handle,&dt);
	close(handle);
	return(status);
}
#ifdef	TEST
main()
{
	auto	char	ls[BUFSIZ];
	auto	char	tf[BUFSIZ];
	auto	char	xf[BUFSIZ];
	struct	stat	sb;
	auto	int		rt;
	auto	long	mt[2];
	auto	long	now;
	while(putchar('?'),gets(ls))	{
		switch(ls[0])	{
			case	'#':
				{
				auto	long	burp;
				extern	long	atol();
				burp = atol(ls+1);
				printf("%ld %s",burp,ctime(&burp));
				burp = ktimestd(burp,U2D);
				printf("%ld %s",burp,ctime(&burp));
				}
				break;
			case	'^':
				putenv("TZ=");
				break;
			case	'+':
				time(&now);
				printf("%s",ctime(&now));
				break;
			case	'*':
				rt = dstat(ls+1,&sb);
				mt[0] = mt[1] = sb.st_mtime;
				printf("%s %ld %s",ls+1,mt[0],ctime(&mt[0]));
				break;
			case	'?':
				rt = dstat(xf,&sb);
				mt[0] = mt[1] = sb.st_mtime;
				printf("%s %ld %s",xf,mt[0],ctime(&mt[0]));
				rt = dstat(tf,&sb);
				mt[0] = mt[1] = sb.st_mtime;
				printf("%s %ld %s",tf,mt[0],ctime(&mt[0]));
				break;
			case	'!':	system(ls+1);break;
			case	'<':	strcpy(xf,ls+1);break;
			case	'>':	strcpy(tf,ls+1);break;
			case	'@':	
				rt = dstat(xf,&sb);
				mt[0] = mt[1] = sb.st_mtime;
				printf("%s %ld %s",xf,mt[0],ctime(&mt[0]));
				rt = utime(tf,mt);
				rt = dstat(tf,&sb);
				mt[0] = mt[1] = sb.st_mtime;
				printf("%s %ld %s",tf,mt[0],ctime(&mt[0]));
				break;
			default:
				puts("\007");
				break;
			}
		}
}
dstat(is,sb)
char	*is;
struct	stat	*sb;
{
	auto	int		rt;
/*
	static	long	shit = 0L;
	if(shit == 0L)	{
		time(&shit);
		ctime(&shit);
		}
*/
	return(stat(is,sb));
}
#endif
#include	<dos.h>
/**/
long
dtimestd()
{
	auto	struct	date	dos_date;
	auto	struct	time	dos_time;
/*
|	establish the long integer value corresponding to 1989:01:01:00:00
|	under the host version of MSDOS
*/
	dos_date.da_year = 1989;
	dos_date.da_day = 1;
	dos_date.da_mon = 1;
	dos_time.ti_min = 0;
	dos_time.ti_hour = 0;
	dos_time.ti_hund = 0;
	dos_time.ti_sec = 0;
	return(dostounix(&dos_date,&dos_time));
}
long
utimestd()
{
#define	UTIMESTD	599644800L	/* 1989:01:01:00:00 */
	return(UTIMESTD);
}
long
ktimeutd(ct)	/* unix to dos */
long	ct;
{
	return(ktimestd(ct,U2D));
}
long
ktimedtu(ct)	/* dos to unix */
long	ct;
{
	return(ktimestd(ct,D2U));
}
long
ktimestd(ct,ty)	/* convert time standard */
long	ct;		/* time to be converted */
int		ty;		/* type of conversion */
{
	static	long	dt = 0L;
	if(dt == 0L)	{
		dt = utimestd() - dtimestd();
		}
/**/
	if(ty == D2U)	{	/* dos to unix */
		if(dt > 0L)	ct += dt;
		else
		if(dt < 0L)	ct -= dt;
		}
	else
	if(ty == U2D)	{	/* unix to dos */
		if(dt > 0L)	ct -= dt;
		else
		if(dt < 0L)	ct += dt;
		}
	else	abort();
/**/
	return(ct);
/**/
}
#endif	/*__TURBOC__*/
