/*DOSLIB*/
/*
**	give msdos a unix style file listing program (sort of)
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/**/
#include    <dos.h>
#include    <dir.h>
#include    <io.h>
#include	<time.h>
#include    <sys/types.h>
#include	<sys/stat.h>
#include	<signal.h>
/**/
#define		MASK	0377
/*GLOBAL*/
char	*files[BLKSIZ];
FUNCP	sfunc;
FUNCP	dfunc;
/**/
/*EXTERN*/
extern	char	*getbase();
extern	int		longform();
extern	int		wideform();
extern	int		lineform();
/**/
/*GLOBAL*/
KENV	kenv;
int   	count = 0;
char	*list;
/**/
alphasort(p1,p2)
char	**p1;
char	**p2;
{
	return(strcmp(*p1,*p2));
}
void
terror(ty)
{
	exit(ty);
}
main(argc,argv)
int     argc;
char    *argv[];
{
/**/
	{
	auto	long	barf;
	time(&barf);
	ctime(&barf);
	}
	dfunc = (FUNCP) wideform;
	sfunc = (FUNCP) alphasort;
/**/
	kenv.dosdos = isdos();
	disnme(kenv.pname = "ls");
/**/
	if(cmdnum(argc,argv,'h',0,DA))	hint(0);
/**/
	kenv.screen = cmdnum(argc,argv,'s',isatty(1) * 22, 22);
/**/
	kenv.flags1 = cmdnum(argc,argv,'f',0,DA);
	if(cmdnum(argc,argv,'1',0,DA))	dfunc = (FUNCP) lineform;
	if(cmdnum(argc,argv,'l',0,DA))	dfunc = (FUNCP) longform;
	if(cmdnum(argc,argv,'w',0,DA))	dfunc = (FUNCP) wideform;
	list = cmdlist(argc,argv,ZERO,"*.*");
	doit(list);
    exit(0);
}
doit(is)
char	*is;
{
	auto	char	ws[FNMSIZ];
	auto	char	*isx = is;
	strcnd(is);
	while((int) (isx = xgnc(ws,ws+FNMSIZ-1,isx,' ')))	{
		strdos(ws);
		if(isnull(ws))	continue;
		else		xfile(ws);
		}
	return(ZERO);
}
xfile(is)
char	*is;
{
	auto   	struct  ffblk   ffblk;
	auto	int	done;
    	auto	char	bs[FNMSIZ];
    	auto	char	ws[FNMSIZ];
    	auto	int	nf = 0;
    	strcpy(ws,is);
/**/
    	getbase(bs,bs+FNMSIZ-1,is);
		strunx(bs);
		strupr(bs);
/**/
    	if(isnull(is))	strcat(ws,"\*.*");
/**/
#ifdef	DEBUG
	printf("xfile(%s,%s)\n",bs,is);
	printf("findfirst(%s)\n",ws);
#endif
    done = findfirst(ws,&ffblk,16);
/**/
    	while(!done)    {
    		if(strcmp(ffblk.ff_name,".") == 0)	;
    		else
    		if(strcmp(ffblk.ff_name,"..") == 0)	;
    		else
    		files[nf++] = strsave(strlwr(ffblk.ff_name));
		done = findnext(&ffblk);
        }
        qsort(files,nf,sizeof(char*),sfunc);
	(*dfunc)(bs,nf);
/**/
    return(count);
}
char	*
getbase(os,us,is)
char	*os;
char	*is;
char	*us;
{	
	auto	char	*eop = strrchr(is,'\\');
	os[0] = ZERO;
	if(eop)	{
		*eop++ = ZERO;
		strkat(os,us,is);
		strcpy(is,eop);
		return(os);
		}
	return(NULL);
}
lineform(bs,nf)
char	*bs;
int	nf;
{
	auto	int	i;
	if(isnull(bs))	bs = ".";
	for(i = 0; i < nf; i++)	{
		if(kenv.flags1 & DA)	{
			fputs(bs,stdout);
			fputs("/",stdout);
			}
		puts(files[i]);
		}
	return(nf);
}
wideform(ps,nf)
char	*ps;
int	nf;
{
	auto	int	i;
	auto	int	j;
/**/
	for(j = i = 0; i < nf; j++, i++)	{
		if(j == 4)	{
			printf("\r\n");
			j = 0;
			}
		printf("%-18.18s",files[i]);
		}
/**/
	printf("\r\n");
/**/
	return(nf);
}
longform(bs,nf)
char	*bs;	/* base path */
int	nf;	/* number of files */
{
    auto    struct  stat    sb;
    auto	char	ws[FNMSIZ];	    	
    auto	int		i;
    for(i = 0; i < nf; i++)	{	
	if(isnull(bs))	strcpy(ws,files[i]);
	else	{
		strcpy(ws,bs);
		strcat(ws,"\\");
		strcat(ws,files[i]);
		}
    if(stat(ws,&sb))	{
    	errmsg("longform <cannot stat> '%s'\n",ws);
    	}
    printf("%03.3o ",sb.st_mode & MASK);
    printf("%6ld ",sb.st_size);
    printf("%24.24s ",ctime(&sb.st_mtime));
    printf("%s\n",files[i]);
	if(i && kenv.screen)	holdfiles(i);
    }
    return(nf);    	
}
holdfiles(lc)
int		lc;
{
	if(!(lc % kenv.screen) && query(stdout) == 'q')	exit(0);
	return(0);
}
hint(ty)
{
static	char	*hx[] = {
"=ls [-options] [file(s)]",
"         list file names",
"=OPTIONS",
"-f       full path names (-1 option)",
"-l       long format",
"-1       one name per line",
"-w       wide format (5 files per line)",
"-s0      stop screen pause (long format)",
"=",
}	;
	prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
	exit(ty);
}
