/*UNXLIB*/
#include        <stdio.h>
#include        <signal.h>
/**/
#define			MASK		0177		/* ascii mask */
/**/
/*EXTERN*/
extern  char    *getenv();
extern  long    time();
extern  FILE    *fopen();
/**/
int             hostpid;                /* pid of login shell */
char            line[BUFSIZ];           /* input line */
long            lcnt;                   /* line count */
long            lmod;                   /* report every lmod lines */
long            totl;                   /* total characters received */
long            rate;                   /* transmission rate */
unsigned        timeout;                /* seconds to wait for time out */
char            *ofn;                   /* output file name */
FILE            *ofp;                   /* output file pointer */
/**/
hangup()
{
		fclose(stdout);
		clearerr(stdin);
        onecho();
		fprintf(stderr,"monitor <waiting for second EOF>\n");
		fflush(stderr);
		alarm(timeout);
		while(fgets(line,BUFSIZ-1,stdin))	;
		if(feof(stdin))	exit(0);
        fprintf(stderr,"monitor <hangup> %ld %ld\n",lcnt,totl);
		fflush(stderr);
        kill(hostpid,SIGHUP);
        kill(hostpid,SIGKILL);
        exit(0);
}
reset()
{
        onecho();
        exit(69);
}
char	ob[BUFSIZ];
char	eb[BUFSIZ];
main(argc,argv)
int     argc;
char    *argv[];
{
		setbuf(stderr,eb);
		setbuf(stdout,ob);
        lcnt = 0L;
        lmod = 100L;
        timeout = 30;
        hostpid = hostid();
        cmdset(argc,argv);
        setofn();
        signal(SIGINT,reset);
        signal(SIGALRM,hangup);
        noecho();
        getfile();
        hangup();
}
hostid()
{
        auto    char    *hostpid;
        hostpid = getenv("HOSTPID");
        if(hostpid == NULL)     {
                fprintf(stderr,"<undefined> HOSTPID\n");
				fflush(stderr);
                exit(69);
                }
        return(atoi(hostpid));
}
getfile()
{
        auto    long    hajime;
        auto    long    genzai;
        time(&hajime);
        while(1)        {
                alarm(timeout);
                if(!fgets(line,BUFSIZ-1,stdin)) break;
                fputs(line,ofp);
				fflush(ofp);
                if(ferror(ofp)) {
                        fprintf(stderr,"<write error>\n");
						fflush(stderr);
                        hangup();
                        exit(69);
                        }
                lcnt += 1;
                totl += strlen(line);
                if(lmod && lcnt % lmod == 0)    {
                        time(&genzai);
                        genzai = genzai - hajime;
                        rate = totl / genzai;
                        fprintf(stderr,"l %6ld c %6ld b %3ld\r",lcnt,totl,rate);
						fflush(stderr);
                        }
                }
		rate = 0L;
		fprintf(stderr,"EOF ");
		fprintf(stderr,"l %6ld c %6ld b %3ld\n",lcnt,totl,rate);
		fflush(stderr);
}
noecho()
{
        system("stty -echo");
}
onecho()
{
        system("stty echo");
}
setofn()
{
        static  char    wfn[128];
        auto    int     barf;
        do      {
                barf = rand();
                barf &= 0111111;
                sprintf(ofn = wfn,"up%06d.tmp",barf);
                }
        while(access(ofn,04) == 0)      ;
        ofp = fopen(ofn,"w");
        if(!ofp)        {
                fprintf(stderr,"monitor <cannot open> '%s'\n",ofn);
				fflush(stderr);
                exit(69);
                }
        fprintf(stderr,"monitor <writing> '%s'\n",ofn);
		fflush(stderr);
        return;
}
cmdset(argc,argv)
int             argc;
char    *argv[];
{
        auto    unsigned        ix;
        auto    char            *psx;
        for(ix = 1; ix < argc; ix++)    {
                psx = argv[ix];
                while(*psx)     switch(*psx++)  {
                        case    '0':
                        case    '1':
                        case    '2':
                        case    '3':
                        case    '4':
                        case    '5':
                        case    '6':
                        case    '7':
                        case    '8':
                        case    '9':    break;
                        case    '-':    break;
                        case    'r':    lmod = atoi(psx);break;
                        case    't':    timeout = atoi(psx);break;
                        case    'h':    usage(stdout);break;
                        }
                }
        return;
}
static  char    *us[] = {
        "==========",
        "monitor [-options]",
        "==========",
        "*",
        "*  read standard input. write to file upXXXXXX.tmp.",
        "*  hangup if no input received for -tNN seconds.",
        "*",
        "==========",
        "-rNN    report every NN lines [100]",
        "-tNN    set time out interval [30]",
        "==========",
        NULL,
        }       ;
usage(fp)
FILE    *fp;
{
        auto    char    **usx = us;
        while(*usx)     {
                fputs(*usx++,fp);
                fputs("\n",fp);
                }
        if(fp == stdout)        exit(0);
        else                    exit(69);
}
